// =============================================================================
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2007-2008 - INRIA
//
//  This file is distributed under the same license as the Scilab package.
// =============================================================================

//===============================
// unit tests regexp
//===============================

if regexp('abc'                                     ,'/abc/'                                 ) <>  1   then pause,end
if regexp('xbc'                                     ,'/abc/'                                 ) <>  []  then pause,end
if regexp('axc'                                     ,'/abc/'                                 ) <>  []  then pause,end
if regexp('abx'                                     ,'/abc/'                                 ) <>  []  then pause,end
if regexp('xabcy'                                   ,'/abc/'                                 ) <>  2   then pause,end
if regexp('ababc'                                   ,'/abc/'                                 ) <>  3   then pause,end
if regexp('abc'                                     ,'/ab*c/'                                ) <>  1   then pause,end
if regexp('abc'                                     ,'/ab*bc/'                               ) <>  1   then pause,end
if regexp('abbc'                                    ,'/ab*bc/'                               ) <>  1   then pause,end
if regexp('abbbbc'                                  ,'/ab*bc/'                               ) <>  1   then pause,end
if regexp('abbbbc'                                  ,'/.{1}/'                                ) <>  1   then pause,end
if regexp('abbbbc'                                  ,'/.{3,4}/'                              ) <>  1   then pause,end
if regexp('abbbbc'                                  ,'/ab{0,}bc/'                            ) <>  1   then pause,end
if regexp('abbc'                                    ,'/ab+bc/'                               ) <>  1   then pause,end
if regexp('abc'                                     ,'/ab+bc/'                               ) <>  []  then pause,end
if regexp('abq'                                     ,'/ab+bc/'                               ) <>  []  then pause,end
if regexp('abq'                                     ,'/ab{1,}bc/'                            ) <>  []  then pause,end
if regexp('abbbbc'                                  ,'/ab+bc/'                               ) <>  1   then pause,end
if regexp('abbbbc'                                  ,'/ab{1,}bc/'                            ) <>  1   then pause,end
if regexp('abbbbc'                                  ,'/ab{1,3}bc/'                           ) <>  1   then pause,end
if regexp('abbbbc'                                  ,'/ab{3,4}bc/'                           ) <>  1   then pause,end
if regexp('abbbbc'                                  ,'/ab{4,5}bc/'                           ) <>  []  then pause,end
if regexp('abbc'                                    ,'/ab?bc/'                               ) <>  1   then pause,end
if regexp('abc'                                     ,'/ab?bc/'                               ) <>  1   then pause,end
if regexp('abc'                                     ,'/ab{0,1}bc/'                           ) <>  1   then pause,end
if regexp('abbbbc'                                  ,'/ab?bc/'                               ) <>  []  then pause,end
if regexp('abc'                                     ,'/ab?c/'                                ) <>  1   then pause,end
if regexp('abc'                                     ,'/ab{0,1}c/'                            ) <>  1   then pause,end
if regexp('abc'                                     ,'/^abc$/'                               ) <>  1   then pause,end
if regexp('abcc'                                    ,'/^abc$/'                               ) <>  []  then pause,end
if regexp('abcc'                                    ,'/^abc/'                                ) <>  1   then pause,end
if regexp('aabc'                                    ,'/^abc$/'                               ) <>  []  then pause,end
if regexp('aabc'                                    ,'/abc$/'                                ) <>  2   then pause,end
if regexp('aabcd'                                   ,'/abc$/'                                ) <>  []  then pause,end
if regexp('abc'                                     ,'/^/'                                   ) <>  1   then pause,end
if regexp('abc'                                     ,'/$/'                                   ) <>  3   then pause,end
if regexp('abc'                                     ,'/a.c/'                                 ) <>  1   then pause,end
if regexp('axc'                                     ,'/a.c/'                                 ) <>  1   then pause,end
if regexp('axyzc'                                   ,'/a.*c/'                                ) <>  1   then pause,end
if regexp('axyzd'                                   ,'/a.*c/'                                ) <>  []  then pause,end
if regexp('abc'                                     ,'/a[bc]d/'                              ) <>  []  then pause,end
if regexp('abd'                                     ,'/a[bc]d/'                              ) <>  1   then pause,end
if regexp('abd'                                     ,'/a[b-d]e/'                             ) <>  []  then pause,end
if regexp('ace'                                     ,'/a[b-d]e/'                             ) <>  1   then pause,end
if regexp('aac'                                     ,'/a[b-d]/'                              ) <>  2   then pause,end
if regexp('a-'                                      ,'/a[-b]/'                               ) <>  1   then pause,end
if regexp('a-'                                      ,'/a[b-]/'                               ) <>  1   then pause,end
if regexp('a]'                                      ,'/a]/'                                  ) <>  1   then pause,end
if regexp('a]b'                                     ,'/a[]]b/'                               ) <>  1   then pause,end
if regexp('aed'                                     ,'/a[^bc]d/'                             ) <>  1   then pause,end
if regexp('abd'                                     ,'/a[^bc]d/'                             ) <>  []  then pause,end
if regexp('adc'                                     ,'/a[^-b]c/'                             ) <>  1   then pause,end
if regexp('a-c'                                     ,'/a[^-b]c/'                             ) <>  []  then pause,end
if regexp('a]c'                                     ,'/a[^]b]c/'                             ) <>  []  then pause,end
if regexp('adc'                                     ,'/a[^]b]c/'                             ) <>  1   then pause,end
if regexp('a-'                                      ,'/\ba\b/'                               ) <>  1   then pause,end
if regexp('-a'                                      ,'/\ba\b/'                               ) <>  2   then pause,end
if regexp('-a-'                                     ,'/\ba\b/'                               ) <>  2   then pause,end
if regexp('xy'                                      ,'/\by\b/'                               ) <>  []  then pause,end
if regexp('yz'                                      ,'/\by\b/'                               ) <>  []  then pause,end
if regexp('xyz'                                     ,'/\by\b/'                               ) <>  []  then pause,end
if regexp('a-'                                      ,'/\Ba\B/'                               ) <>  []  then pause,end
if regexp('-a'                                      ,'/\Ba\B/'                               ) <>  []  then pause,end
if regexp('-a-'                                     ,'/\Ba\B/'                               ) <>  []  then pause,end
if regexp('xy'                                      ,'/\By\b/'                               ) <>  2   then pause,end
if regexp('xy'                                      ,'/\By\b/'                               ) <>  2   then pause,end
if regexp('yz'                                      ,'/\by\B/'                               ) <>  1   then pause,end
if regexp('xyz'                                     ,'/\By\B/'                               ) <>  2   then pause,end
if regexp('a'                                       ,'/\w/'                                  ) <>  1   then pause,end
if regexp('-'                                       ,'/\w/'                                  ) <>  []  then pause,end
if regexp('a'                                       ,'/\W/'                                  ) <>  []  then pause,end
if regexp('-'                                       ,'/\W/'                                  ) <>  1   then pause,end
if regexp('a b'                                     ,'/a\sb/'                                ) <>  1   then pause,end
if regexp('a-b'                                     ,'/a\sb/'                                ) <>  []  then pause,end
if regexp('a b'                                     ,'/a\Sb/'                                ) <>  []  then pause,end
if regexp('a-b'                                     ,'/a\Sb/'                                ) <>  1   then pause,end
if regexp('1'                                       ,'/\d/'                                  ) <>  1   then pause,end
if regexp('-'                                       ,'/\d/'                                  ) <>  []  then pause,end
if regexp('1'                                       ,'/\D/'                                  ) <>  []  then pause,end
if regexp('-'                                       ,'/\D/'                                  ) <>  1   then pause,end
if regexp('a'                                       ,'/[\w]/'                                ) <>  1   then pause,end
if regexp('-'                                       ,'/[\w]/'                                ) <>  []  then pause,end
if regexp('a'                                       ,'/[\W]/'                                ) <>  []  then pause,end
if regexp('-'                                       ,'/[\W]/'                                ) <>  1   then pause,end
if regexp('a b'                                     ,'/a[\s]b/'                              ) <>  1   then pause,end
if regexp('a-b'                                     ,'/a[\s]b/'                              ) <>  []  then pause,end
if regexp('a b'                                     ,'/a[\S]b/'                              ) <>  []  then pause,end
if regexp('a-b'                                     ,'/a[\S]b/'                              ) <>  1   then pause,end
if regexp('1'                                       ,'/[\d]/'                                ) <>  1   then pause,end
if regexp('-'                                       ,'/[\d]/'                                ) <>  []  then pause,end
if regexp('1'                                       ,'/[\D]/'                                ) <>  []  then pause,end
if regexp('-'                                       ,'/[\D]/'                                ) <>  1   then pause,end
if regexp('abc'                                     ,'/ab|cd/'                               ) <>  1   then pause,end
if regexp('abcd'                                    ,'/ab|cd/'                               ) <>  1   then pause,end
if regexp('b'                                       ,'/$b/'                                  ) <>  []  then pause,end
if regexp('ab'                                      ,'/a\(*b/'                               ) <>  1   then pause,end
if regexp('a((b'                                    ,'/a\(*b/'                               ) <>  1   then pause,end
if regexp('aabbabc'                                 ,'/a+b+c/'                               ) <>  5   then pause,end
if regexp('aabbabc'                                 ,'/a{1,}b{1,}c/'                         ) <>  5   then pause,end
if regexp('abcabc'                                  ,'/a.+?c/'                               ) <>  1   then pause,end
if regexp('cde'                                     ,'/[^ab]*/'                              ) <>  1   then pause,end
if regexp(''                                        ,'/abc/'                                 ) <>  []  then pause,end
if regexp(''                                        ,'/a*/'                               ) <> 1  then pause,end
if regexp('e'                                       ,'/a|b|c|d|e/'                           ) <>  1   then pause,end
if regexp('abcdefg'                                 ,'/abcd*efg/'                            ) <>  1   then pause,end
if regexp('xabyabbbz'                               ,'/ab*/'                                 ) <>  [2 5]   then pause,end
if regexp('xayabbbz'                                ,'/ab*/'                              ) <>  [2 4]   then pause,end
if regexp('hij'                                     ,'/[abhgefdc]ij/'                        ) <>  1   then pause,end
if regexp('abcde'                                   ,'/^(ab|cd)e/'                           ) <>  []  then pause,end
if regexp('adcdcde'                                 ,'/a[bcd]*dcdcde/'                       ) <>  1   then pause,end
if regexp('adcdcde'                                 ,'/a[bcd]+dcdcde/'                       ) <>  []  then pause,end
if regexp('alpha'                                   ,'/[a-zA-Z_][a-zA-Z0-9_]*/'              ) <>  1   then pause,end
if regexp('effg'                                    ,'/(bc+d$|ef*g.|h?i(j|k))/'              ) <>  []  then pause,end
if regexp('bcdd'                                    ,'/(bc+d$|ef*g.|h?i(j|k))/'              ) <>  []  then pause,end
if regexp('aa'                                      ,'/((((((((((a))))))))))\10/'            ) <>  1   then pause,end
if regexp('aa'                                      ,'/((((((((((a))))))))))\041/'           ) <>  []  then pause,end
if regexp('a!'                                      ,'/((((((((((a))))))))))\041/'           ) <>  1   then pause,end
if regexp('a'                                       ,'/(((((((((a)))))))))/'                 ) <>  1   then pause,end
if regexp('uh-uh'                                   ,'/multiple words of text/'              ) <>  []  then pause,end
if regexp('multiple words, yeah'                    ,'/multiple words/'                      ) <>  1   then pause,end
if regexp('ab'                                      ,'/[k]/'                                 ) <>  []  then pause,end
if regexp('ac'                                      ,'/a[-]?c/'                              ) <>  1   then pause,end
if regexp('a'                                       ,'/(a)|\1/'                              ) <>  1   then pause,end
if regexp('x'                                       ,'/(a)|\1/'                              ) <>  []  then pause,end
if regexp('aaxabxbaxbbx'                            ,'/((\3|b)\2(a)x)+/'                     ) <>  []  then pause,end
if regexp('ABC'                                     ,'/abc/i'                                ) <>  1   then pause,end
if regexp('XBC'                                     ,'/abc/i'                                ) <>  []  then pause,end
if regexp('AXC'                                     ,'/abc/i'                                ) <>  []  then pause,end
if regexp('ABX'                                     ,'/abc/i'                                ) <>  []  then pause,end
if regexp('XABCY'                                   ,'/abc/i'                                ) <>  2   then pause,end
if regexp('ABABC'                                   ,'/abc/i'                                ) <>  3   then pause,end
if regexp('ABC'                                     ,'/ab*c/i'                               ) <>  1   then pause,end
if regexp('ABC'                                     ,'/ab*bc/i'                              ) <>  1   then pause,end
if regexp('ABBC'                                    ,'/ab*bc/i'                              ) <>  1   then pause,end
if regexp('ABBBBC'                                  ,'/ab*?bc/i'                             ) <>  1   then pause,end
if regexp('ABBBBC'                                  ,'/ab{0,}?bc/i'                          ) <>  1   then pause,end
if regexp('ABBC'                                    ,'/ab+?bc/i'                             ) <>  1   then pause,end
if regexp('ABC'                                     ,'/ab+bc/i'                              ) <>  []  then pause,end
if regexp('ABQ'                                     ,'/ab+bc/i'                              ) <>  []  then pause,end
if regexp('ABQ'                                     ,'/ab{1,}bc/i'                           ) <>  []  then pause,end
if regexp('ABBBBC'                                  ,'/ab+bc/i'                              ) <>  1   then pause,end
if regexp('ABBBBC'                                  ,'/ab{1,}?bc/i'                          ) <>  1   then pause,end
if regexp('ABBBBC'                                  ,'/ab{1,3}?bc/i'                         ) <>  1   then pause,end
if regexp('ABBBBC'                                  ,'/ab{3,4}?bc/i'                         ) <>  1   then pause,end
if regexp('ABBBBC'                                  ,'/ab{4,5}?bc/i'                         ) <>  []  then pause,end
if regexp('ABBC'                                    ,'/ab??bc/i'                             ) <>  1   then pause,end
if regexp('ABC'                                     ,'/ab??bc/i'                             ) <>  1   then pause,end
if regexp('ABC'                                     ,'/ab{0,1}?bc/i'                         ) <>  1   then pause,end
if regexp('ABBBBC'                                  ,'/ab??bc/i'                             ) <>  []  then pause,end
if regexp('ABC'                                     ,'/ab??c/i'                              ) <>  1   then pause,end
if regexp('ABC'                                     ,'/ab{0,1}?c/i'                          ) <>  1   then pause,end
if regexp('ABC'                                     ,'/^abc$/i'                              ) <>  1   then pause,end
if regexp('ABCC'                                    ,'/^abc$/i'                              ) <>  []  then pause,end
if regexp('ABCC'                                    ,'/^abc/i'                               ) <>  1   then pause,end
if regexp('AABC'                                    ,'/^abc$/i'                       ) <>  []  then pause,end
if regexp('AABC'                                    ,'/abc$/i'                               ) <>  2   then pause,end
if regexp('ABC'                                     ,'/^/i'                           ) <>  1   then pause,end
if regexp('ABC'                                     ,'/$/i'                                  ) <>  3   then pause,end
if regexp('ABC'                                     ,'/a.c/i'                                ) <>  1   then pause,end
if regexp('AXC'                                     ,'/a.c/i'                                ) <>  1   then pause,end
if regexp('AXYZC'                                   ,'/a.*?c/i'                              ) <>  1   then pause,end
if regexp('AXYZD'                                   ,'/a.*c/i'                               ) <>  []  then pause,end
if regexp('ABC'                                     ,'/a[bc]d/i'                             ) <>  []  then pause,end
if regexp('ABD'                                     ,'/a[bc]d/i'                             ) <>  1   then pause,end
if regexp('ABD'                                     ,'/a[b-d]e/i'                            ) <>  []  then pause,end
if regexp('ACE'                                     ,'/a[b-d]e/i'                            ) <>  1   then pause,end
if regexp('AAC'                                     ,'/a[b-d]/i'                             ) <>  2   then pause,end
if regexp('A-'                                      ,'/a[-b]/i'                              ) <>  1   then pause,end
if regexp('A-'                                      ,'/a[b-]/i'                              ) <>  1   then pause,end
if regexp('A]'                                      ,'/a]/i'                                 ) <>  1   then pause,end
if regexp('A]B'                                     ,'/a[]]b/i'                              ) <>  1   then pause,end
if regexp('AED'                                     ,'/a[^bc]d/i'                            ) <>  1   then pause,end
if regexp('ABD'                                     ,'/a[^bc]d/i'                            ) <>  []  then pause,end
if regexp('ADC'                                     ,'/a[^-b]c/i'                            ) <>  1   then pause,end
if regexp('A-C'                                     ,'/a[^-b]c/i'                            ) <>  []  then pause,end
if regexp('A]C'                                     ,'/a[^]b]c/i'                            ) <>  []  then pause,end
if regexp('ADC'                                     ,'/a[^]b]c/i'                            ) <>  1   then pause,end
if regexp('ABC'                                     ,'/ab|cd/i'                              ) <>  1   then pause,end
if regexp('ABCD'                                    ,'/ab|cd/i'                              ) <>  1   then pause,end
if regexp('B'                                       ,'/$b/i'                                 ) <>  []  then pause,end
if regexp('AB'                                      ,'/a\(*b/i'                              ) <>  1   then pause,end
if regexp('A((B'                                    ,'/a\(*b/i'                              ) <>  1   then pause,end
if regexp('AABBABC'                                 ,'/a+b+c/i'                              ) <>  5   then pause,end
if regexp('AABBABC'                                 ,'/a{1,}b{1,}c/i'                        ) <>  5   then pause,end
if regexp('ABCABC'                                  ,'/a.+?c/i'                              ) <>  [1 4]   then pause,end
if regexp('ABCABC'                                  ,'/a.*?c/i'                              ) <>  1   then pause,end
if regexp('ABCABC'                                  ,'/a.{0,5}?c/i'                          ) <>  1   then pause,end
if regexp('CDE'                                     ,'/[^ab]*/i'                             ) <>  1   then pause,end
if regexp(''                                        ,'/abc/i'                                ) <>  []  then pause,end
if regexp(''                                        ,'/a*/i'                               ) <>  1  then pause,end
if regexp('E'                                       ,'/a|b|c|d|e/i'                          ) <>  1   then pause,end
if regexp('ABCDEFG'                                 ,'/abcd*efg/i'                           ) <>  1   then pause,end
if regexp('XABYABBBZ'                               ,'/ab*/i'                                ) <>  [2 5]   then pause,end
if regexp('XAYABBBZ'                                ,'/ab*/i'                                ) <>  [2 4]   then pause,end
if regexp('HIJ'                                     ,'/[abhgefdc]ij/i'                       ) <>  1   then pause,end
if regexp('ABCDE'                                   ,'/^(ab|cd)e/i'                          ) <>  []  then pause,end
if regexp('ADCDCDE'                                 ,'/a[bcd]*dcdcde/i'                      ) <>  1   then pause,end
if regexp('ADCDCDE'                                 ,'/a[bcd]+dcdcde/i'                      ) <>  []  then pause,end
if regexp('ALPHA'                                   ,'/[a-zA-Z_][a-zA-Z0-9_]*/i'             ) <>  1   then pause,end
if regexp('EFFG'                                    ,'/(bc+d$|ef*g.|h?i(j|k))/i'             ) <>  []  then pause,end
if regexp('BCDD'                                    ,'/(bc+d$|ef*g.|h?i(j|k))/i'             ) <>  []  then pause,end
if regexp('AA'                                      ,'/((((((((((a))))))))))\10/i'           ) <>  1   then pause,end
if regexp('AA'                                      ,'/((((((((((a))))))))))\041/i'          ) <>  []  then pause,end
if regexp('A!'                                      ,'/((((((((((a))))))))))\041/i'          ) <>  1   then pause,end
if regexp('A'                                       ,'/(((((((((a)))))))))/i'                ) <>  1   then pause,end
if regexp('UH-UH'                                   ,'/multiple words of text/i'             ) <>  []  then pause,end
if regexp('MULTIPLE WORDS, YEAH'                    ,'/multiple words/i'                     ) <>  1   then pause,end
if regexp('AB'                                      ,'/[k]/i'                                ) <>  []  then pause,end
if regexp('AC'                                      ,'/a[-]?c/i'                             ) <>  1   then pause,end
if regexp('abad'                                    ,'/a(?!b)./'                             ) <>  3   then pause,end
if regexp('abad'                                    ,'/a(?=d)./'                             ) <>  3   then pause,end
if regexp('abad'                                    ,'/a(?=c|d)./'                           ) <>  3   then pause,end
if regexp('<&OUT'                                   ,'/^[<>]&/'                              ) <>  1   then pause,end
if regexp('aaaaaaaaa'                               ,'/^(a\1?){4}$/'                         ) <>  []  then pause,end
if regexp('aaaaaaaaaaa'                             ,'/^(a\1?){4}$/'                         ) <>  []  then pause,end
if regexp('aaaaaaaaa'                               ,'/^(a(?(1)\1)){4}$/'                    ) <>  []  then pause,end
if regexp('aaaaaaaaaaa'                             ,'/^(a(?(1)\1)){4}$/'                    ) <>  []  then pause,end
if regexp('ab'                                      ,'/(?<=a)b/'                             ) <>  2   then pause,end
if regexp('cb'                                      ,'/(?<=a)b/'                             ) <>  []  then pause,end
if regexp('b'                                       ,'/(?<=a)b/'                             ) <>  []  then pause,end
if regexp('ab'                                      ,'/(?<!c)b/'                             ) <>  2   then pause,end
if regexp('cb'                                      ,'/(?<!c)b/'                             ) <>  []  then pause,end
if regexp('b'                                       ,'/(?<!c)b/'                             ) <>  1   then pause,end
if regexp('b'                                       ,'/(?<!c)b/'                             ) <>  1   then pause,end
if regexp('aba'                                     ,'/(?:..)*a/'                            ) <>  1   then pause,end
if regexp('aba'                                     ,'/(?:..)*?a/'                           ) <>  1   then pause,end
if regexp('abc'                                     ,'/^(?:b|a(?=(.)))*\1/'                  ) <>  1   then pause,end
if regexp('ab'                                      ,'/(?:(?i)a)b/'                          ) <>  1   then pause,end
if regexp('Ab'                                      ,'/(?:(?i)a)b/'                          ) <>  1   then pause,end
if regexp('aB'                                      ,'/(?:(?i)a)b/'                          ) <>  []  then pause,end
if regexp('aB'                                      ,'/((?i)a)b/'                            ) <>  []  then pause,end
if regexp('ab'                                      ,'/(?i:a)b/'                             ) <>  1   then pause,end
if regexp('Ab'                                      ,'/(?i:a)b/'                             ) <>  1   then pause,end
if regexp('aB'                                      ,'/(?i:a)b/'                             ) <>  []  then pause,end
if regexp('aB'                                      ,'/((?i:a))b/'                           ) <>  []  then pause,end
if regexp('ab'                                      ,'/(?:(?-i)a)b/i'                        ) <>  1   then pause,end
if regexp('aB'                                      ,'/(?:(?-i)a)b/i'                        ) <>  1   then pause,end
if regexp('Ab'                                      ,'/(?:(?-i)a)b/i'                        ) <>  []  then pause,end
if regexp('Ab'                                      ,'/((?-i)a)b/i'                          ) <>  []  then pause,end
if regexp('aB'                                      ,'/(?:(?-i)a)b/i'                        ) <>  1   then pause,end
if regexp('AB'                                      ,'/(?:(?-i)a)b/i'                        ) <>  []  then pause,end
if regexp('AB'                                      ,'/((?-i)a)b/i'                          ) <>  []  then pause,end
if regexp('ab'                                      ,'/(?-i:a)b/i'                           ) <>  1   then pause,end
if regexp('aB'                                      ,'/(?-i:a)b/i'                           ) <>  1   then pause,end
if regexp('Ab'                                      ,'/(?-i:a)b/i'                           ) <>  []  then pause,end
if regexp('Ab'                                      ,'/((?-i:a))b/i'                         ) <>  []  then pause,end
if regexp('aB'                                      ,'/(?-i:a)b/i'                           ) <>  1   then pause,end
if regexp('AB'                                      ,'/(?-i:a)b/i'                           ) <>  []  then pause,end
if regexp('AB'                                      ,'/((?-i:a))b/i'                         ) <>  []  then pause,end
if regexp('a\nB'                                    ,'/((?-i:a.))b/i'                        ) <>  []  then pause,end
if regexp('B\nB'                                    ,'/((?s-i:a.))b/i'                       ) <>  []  then pause,end
if regexp('cabbbb'                                  ,'/(?:c|d)(?:)(?:a(?:)(?:b)(?:b(?:))(?:b(?:)(?:b)))/') <>  1   then pause,end
if regexp('caaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb','/(?:c|d)(?:)(?:aaaaaaaa(?:)(?:bbbbbbbb)(?:bbbbbbbb(?:))(?:bbbbbbbb(?:)(?:bbbbbbbb)))/') <>  1   then pause,end
if regexp('foobar1234baz'                           ,'/foo\w*\d{4}baz/'                      ) <>  1   then pause,end
if regexp('x~~'                                     ,'/x(~~)*(?:(?:F)?)?/'                   ) <>  1   then pause,end
if regexp('aaac'                                    ,'/^a(?#xxx){3}c/'                       ) <>  1   then pause,end
if regexp('aaac'                                    ,'/^a (?#xxx) (?#yyy) {3}c/x'            ) <>  1   then pause,end
if regexp('dbcb'                                    ,'/(?<![cd])b/'                          ) <>  []  then pause,end
if regexp('dbaacb'                                  ,'/(?<![cd])[ab]/'                       ) <>  [3 4]   then pause,end
if regexp('dbcb'                                    ,'/(?<!(c|d))b/'                         ) <>  []  then pause,end
if regexp('dbaacb'                                  ,'/(?<!(c|d))[ab]/'                      ) <>  [3 4]   then pause,end
if regexp('cdaccb'                                  ,'/(?<!cd)[ab]/'                         ) <>  6   then pause,end
if regexp('a--'                                     ,'/^(?:a?b?)*$/'                         ) <>  []  then pause,end
if regexp('a\nb\n'                                  ,'/(?m)^b/'                              ) <>  [3 4]   then pause,end
if regexp('a\nb\nc\n'                               ,'/^b/'                                  ) <>  []  then pause,end
if regexp('a\nb\nc\n'                               ,'/()^b/'                                ) <>  []  then pause,end
if regexp('a'                                       ,'/(x)?(?(1)a|b)/'                       ) <>  []  then pause,end
if regexp('a'                                       ,'/(x)?(?(1)b|a)/'                       ) <>  1   then pause,end
if regexp('a'                                       ,'/()?(?(1)b|a)/'                        ) <>  1   then pause,end
if regexp('a'                                       ,'/()(?(1)b|a)/'                         ) <>  []  then pause,end
if regexp('a'                                       ,'/()?(?(1)a|b)/'                        ) <>  1   then pause,end
if regexp('blah)'                                   ,'/^(\()?blah(?(1)(\)))$/'               ) <>  []  then pause,end
if regexp('(blah'                                   ,'/^(\()?blah(?(1)(\)))$/'               ) <>  []  then pause,end
if regexp('blah)'                                   ,'/^(\(+)?blah(?(1)(\)))$/'              ) <>  []  then pause,end
if regexp('(blah'                                   ,'/^(\(+)?blah(?(1)(\)))$/'              ) <>  []  then pause,end
if regexp('a'                                       ,'/(?(?!a)a|b)/'                         ) <>  []  then pause,end
if regexp('a'                                       ,'/(?(?!a)b|a)/'                         ) <>  1   then pause,end
if regexp('a'                                       ,'/(?(?=a)b|a)/'                         ) <>  []  then pause,end
if regexp('a'                                       ,'/(?(?=a)a|b)/'                         ) <>  1   then pause,end
if regexp('aaab'                                    ,'/^(?=(a+?))\1ab/'                      ) <>  []  then pause,end
if regexp('aaab'                                    ,'/^(?=(a+?))\1ab/'                      ) <>  []  then pause,end
if regexp('abcd:'                                   ,'/([\w:]+::)?(\w+)$/'                   ) <>  []  then pause,end
if regexp('abcd:'                                   ,'/([\w:]+::)?(\w+)$/'                   ) <>  []  then pause,end
if regexp('aaab'                                    ,'/(>a+)ab/'                             ) <>  []  then pause,end
if regexp('aaab'                                    ,'/(?>a+)b/'                             ) <>  1   then pause,end
if regexp('abc'                                     ,'/[a[:]b[:c]/'                          ) <>  1   then pause,end
if regexp('abc'                                     ,'/[a[:]b[:c]/'                          ) <>  1   then pause,end
if regexp('((abc(ade)ufh()()x'                      ,'/((?>[^()]+)|\([^()]*\))+/'            ) <>  3   then pause,end
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
if regexp('a\nb\n'                                  ,'/a\Z/'                                 ) <>  []  then pause,end
if regexp('a\nb\n'                                  ,'/a\z/'                                 ) <>  []  then pause,end
if regexp('a\nb\n'                                  ,'/a$/'                                  ) <>  []  then pause,end
if regexp('b\na\n'                                  ,'/a\z/'                                 ) <>  []  then pause,end
if regexp('a\nb\n'                                  ,'/a\Z/m'                                ) <>  []  then pause,end
if regexp('a\nb\n'                                  ,'/a\z/m'                                ) <>  []  then pause,end
if regexp('b\na\n'                                  ,'/a\z/m'                                ) <>  []  then pause,end
if regexp('aa\nb\n'                                 ,'/aa\Z/'                                ) <>  []  then pause,end
if regexp('aa\nb\n'                                 ,'/aa\z/'                                ) <>  []  then pause,end
if regexp('aa\nb\n'                                 ,'/aa$/'                                 ) <>  []  then pause,end
if regexp('b\naa\n'                                 ,'/aa\z/'                                ) <>  []  then pause,end
if regexp('aa\nb\n'                                 ,'/aa\Z/m'                               ) <>  []  then pause,end
if regexp('aa\nb\n'                                 ,'/aa\z/m'                               ) <>  []  then pause,end
if regexp('b\naa\n'                                 ,'/aa\z/m'                               ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/aa\Z/'                                ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/aa\z/'                                ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/aa$/'                                 ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/aa\Z/'                                ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/aa\z/'                                ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/aa$/'                                 ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/aa\Z/'                                ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/aa\z/'                                ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/aa$/'                                 ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/aa\Z/m'                               ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/aa\z/m'                               ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/aa$/m'                                ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/aa\Z/m'                               ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/aa\z/m'                               ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/aa$/m'                                ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/aa\Z/m'                               ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/aa\z/m'                               ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/aa$/m'                                ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/aa\Z/'                                ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/aa\z/'                                ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/aa$/'                                 ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/aa\Z/'                                ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/aa\z/'                                ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/aa$/'                                 ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/aa\Z/'                                ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/aa\z/'                                ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/aa$/'                                 ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/aa\Z/m'                               ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/aa\z/m'                               ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/aa$/m'                                ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/aa\Z/m'                               ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/aa\z/m'                               ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/aa$/m'                                ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/aa\Z/m'                               ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/aa\z/m'                               ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/aa$/m'                                ) <>  []  then pause,end
if regexp('ab\nb\n'                                 ,'/ab\Z/'                                ) <>  []  then pause,end
if regexp('ab\nb\n'                                 ,'/ab\z/'                                ) <>  []  then pause,end
if regexp('ab\nb\n'                                 ,'/ab$/'                                 ) <>  []  then pause,end
if regexp('b\nab\n'                                 ,'/ab\z/'                                ) <>  []  then pause,end
if regexp('ab\nb\n'                                 ,'/ab\Z/m'                               ) <>  []  then pause,end
if regexp('ab\nb\n'                                 ,'/ab\z/m'                               ) <>  []  then pause,end
if regexp('b\nab\n'                                 ,'/ab\z/m'                               ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/ab\Z/'                                ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/ab\z/'                                ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/ab$/'                                 ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/ab\Z/'                                ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/ab\z/'                                ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/ab$/'                                 ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/ab\Z/'                                ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/ab\z/'                                ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/ab$/'                                 ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/ab\Z/m'                               ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/ab\z/m'                               ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/ab$/m'                                ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/ab\Z/m'                               ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/ab\z/m'                               ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/ab$/m'                                ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/ab\Z/m'                               ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/ab\z/m'                               ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/ab$/m'                                ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/ab\Z/'                                ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/ab\z/'                                ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/ab$/'                                 ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/ab\Z/'                                ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/ab\z/'                                ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/ab$/'                                 ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/ab\Z/'                                ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/ab\z/'                                ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/ab$/'                                 ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/ab\Z/m'                               ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/ab\z/m'                               ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/ab$/m'                                ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/ab\Z/m'                               ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/ab\z/m'                               ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/ab$/m'                                ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/ab\Z/m'                               ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/ab\z/m'                               ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/ab$/m'                                ) <>  []  then pause,end
if regexp('abb\nb\n'                                ,'/abb\Z/'                               ) <>  []  then pause,end
if regexp('abb\nb\n'                                ,'/abb\z/'                               ) <>  []  then pause,end
if regexp('abb\nb\n'                                ,'/abb$/'                                ) <>  []  then pause,end
if regexp('b\nabb\n'                                ,'/abb\z/'                               ) <>  []  then pause,end
if regexp('abb\nb\n'                                ,'/abb\Z/m'                              ) <>  []  then pause,end
if regexp('abb\nb\n'                                ,'/abb\z/m'                              ) <>  []  then pause,end
if regexp('b\nabb\n'                                ,'/abb\z/m'                              ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/abb\Z/'                               ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/abb\z/'                               ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/abb$/'                                ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/abb\Z/'                               ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/abb\z/'                               ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/abb$/'                                ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/abb\Z/'                               ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/abb\z/'                               ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/abb$/'                                ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/abb\Z/m'                              ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/abb\z/m'                              ) <>  []  then pause,end
if regexp('ac\nb\n'                                 ,'/abb$/m'                               ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/abb\Z/m'                              ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/abb\z/m'                              ) <>  []  then pause,end
if regexp('b\nac\n'                                 ,'/abb$/m'                               ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/abb\Z/m'                              ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/abb\z/m'                              ) <>  []  then pause,end
if regexp('b\nac'                                   ,'/abb$/m'                               ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/abb\Z/'                               ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/abb\z/'                               ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/abb$/'                                ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/abb\Z/'                               ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/abb\z/'                               ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/abb$/'                                ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/abb\Z/'                               ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/abb\z/'                               ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/abb$/'                                ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/abb\Z/m'                              ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/abb\z/m'                              ) <>  []  then pause,end
if regexp('ca\nb\n'                                 ,'/abb$/m'                               ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/abb\Z/m'                              ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/abb\z/m'                              ) <>  []  then pause,end
if regexp('b\nca\n'                                 ,'/abb$/m'                               ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/abb\Z/m'                              ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/abb\z/m'                              ) <>  []  then pause,end
if regexp('b\nca'                                   ,'/abb$/m'                               ) <>  []  then pause,end
if regexp('x'                                       ,'/a*abc?xyz+pqr{3}ab{2,}xy{4,5}pq{0,6}AB{0,}zz/') <>  []  then pause,end
if regexp('foo.bart'                                ,'/foo.bart/'                            ) <>  1   then pause,end
if regexp('abcd\ndxxx'                              ,'/^d[x][x][x]/m'                        ) <>  6   then pause,end
if regexp('xxxtt'                                   ,'/tt+$/'                                ) <>  4   then pause,end
if regexp('aaaXbX'                                  ,'/\GX.*X/'                              ) <>  []  then pause,end
if regexp('Changes'                                 ,'/\.c(pp|xx|c)?$/i'                     ) <>  []  then pause,end
if regexp('IO.c'                                    ,'/\.c(pp|xx|c)?$/i'                     ) <>  3   then pause,end
if regexp('C:/'                                     ,'/^([a-z]:)/'                           ) <>  []  then pause,end
if regexp('\nx aa'                                  ,'/^\S\s+aa$/m'                          ) <>  2   then pause,end
if regexp('ab'                                      ,'/(^|a)b/'                              ) <>  1   then pause,end
if regexp('abcab'                                   ,'/(\w)?(abc)\1b/'                       ) <>  []  then pause,end
if regexp('a,b,c'                                   ,'/^(?:.,){2}c/'                         ) <>  1   then pause,end
if regexp('a,b,c'                                   ,'/^(?:[^,]*,){2}c/'                     ) <>  1   then pause,end
if regexp(''                                        ,'/(?i)/'                                ) <>  1  then pause,end
if regexp('a\nxb\n'                                 ,'/(?!\A)x/m'                            ) <>  3   then pause,end
if regexp('123\nabcabcabcabc\n'                     ,'/^.{9}abc.*\n/m'                       ) <>  5   then pause,end
if regexp('a'                                       ,'/^(a)?(?(1)a|b)+$/'                    ) <>  []  then pause,end
if regexp('x1'                                      ,'/^(0+)?(?:x(1))?/'                     ) <>  1   then pause,end
if regexp('012cxx0190'                              ,'/^([0-9a-fA-F]+)(?:x([0-9a-fA-F]+)?)(?:x([0-9a-fA-F]+))?/') <>  1   then pause,end
if regexp('aaaacccc'                                ,'/((?:aaaa|bbbb)cccc)?/'                ) <>  1   then pause,end
if regexp('bbbbcccc'                                ,'/((?:aaaa|bbbb)cccc)?/'                ) <>  1   then pause,end
if regexp('a\nb\n'                                  ,'/b\s^/m'                               ) <>  []  then pause,end
if regexp('a'                                       ,'/\ba/'                                 ) <>  1   then pause,end
if regexp('AbCd'                                    ,'/ab(?i)cd/'                            ) <>  []  then pause,end
if regexp('abCd'                                    ,'/ab(?i)cd/'                            ) <>  1   then pause,end
if regexp('Oo'                                      ,'/^(o)(?!.*\1)/i'                       ) <>  []  then pause,end
if regexp('2'                                       ,'/2(]*)?$\1/'                           ) <>  1   then pause,end
if regexp('......abef'                              ,'/.*a(?!(b|cd)*e).*f/'                  ) <>  []  then pause,end
if regexp('fools'                                   ,'/(foo|fool|x.|money|parted)$/'         ) <>  []  then pause,end
if regexp('fools'                                   ,'/(x.|foo|fool|x.|money|parted|y.)$/'   ) <>  []  then pause,end
if regexp('fools'                                   ,'/(foo|fool|money|parted)$/'            ) <>  []  then pause,end
